Subject: Re: [PATCH] Allow to control the namespace for replace refs

From: Junio C Hamano <[email-masked]>
Date: Thu, 11 Jun 2015 13:55:01 -0700

Mike Hommey <[email-masked]> writes:

> On Thu, Jun 11, 2015 at 08:16:02AM -0700, Junio C Hamano wrote:
>> Mike Hommey <[email-masked]> writes:
>> 
>> > I do agree that this is all confusing, but allow me to point out that
>> > it's already plenty confusing: "namespace" is a term that has been used to
>> > designate a generic kind of namespace *and* refs/namespaces. See for
>> > example:
>> >
>> > https://github.com/git/git/blob/master/Documentation/git-describe.txt#L39
>> > https://github.com/git/git/blob/master/Documentation/git-fetch.txt#L113
>> > https://github.com/git/git/blob/master/Documentation/git-filter-branch.txt#L36
>> > (note how this one is specifically about refs/replace/)
>> > there are many more.
>> 
>> "One more breakage does not hurt" is not something we want to see.
>
> I won't disagree here, but we are in desperate need for a word for those
> namespaces that aren't refs/namespaces, and stick to it (independently
> of the replace patch), but I've never seen one.

I actually don't agree with you ;-)

All these examples you cited above are merely talking about
hierarchy and they do not have any desperate need for a new word.

They do not even need a technical term; they needed a way of saying
"subdirectory" without limiting their reference to loose refs.  If
there weren't packed-refs, they would have said ".git/refs/heads and
its subdirectories" and that would have been perfectly fine.

The "ref namespace" I mentioned in my first response is the only
special one, I would think, so if we reword everybody else to say
hierarchy instead of namespace, we are perfectly fine, I think.